/***********************************************************************************************************************
* File Name        : falling_block_puzzle.h
* Component Version: 1.0.0
* Device(s)        : R7F100GLGxFA
* Description      :
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro definitions (Register bit)
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro definitions
***********************************************************************************************************************/
#define true 1
#define false 0 
#define FIELD_WIDTH  9
#define FIELD_HEIGHT 17
#define BLOCK_WIDTH 4
#define BLOCK_HEIGHT 4
#define ROTAITION 0x0B
#define RIGHT 0x0E
#define LEFT 0x07
#define UNDER 0x0D

/***********************************************************************************************************************
Typedef definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Global functions
***********************************************************************************************************************/
void Field_Copy(void);
void Screen_Update(void);
unsigned char Block_Hit(unsigned char, unsigned char, unsigned char, unsigned char);
void Sw_Process(void);
void Block_Reset(void);
void Line_Filled_Check(void);

enum {
	STICK_BLOCK,
	SQUARE_BLOCK,
	MOUNT_BLOCK,
	LWORD1_BLOCK,
	LWORD2_BLOCK,
	TWIST1_BLOCK,
	TWIST2_BLOCK,
	BLOCK_MAX,
};

enum {
	BLOCK_ANGLE_0,
	BLOCK_ANGLE_90,
	BLOCK_ANGLE_180,
	BLOCK_ANGLE_270,
	BLOCK_ANGLE_MAX,
};
